﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Threading;
using System.Runtime.InteropServices;
using System.Text;
using System.Xml.Linq;
using System.ComponentModel;
using System.Data;

using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.Plugins.PluginClass;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Logic.Inventory.Frames.Gossip;



namespace Allrounder
{
    public class Firstaider 
    {
        private List<uint> _itemlistband = new List<uint>
        {
            2589, //Linen Cloth
            2592, //Woolen Cloth
            4306,//Silk Cloth
            4338, //Mageweave Cloth
            14047, //RuneCloth
            21877, //Netherweave Cloth
            33470, //Forstweave Cloth
	    
        };
        private List<uint> BandageIds = new List<uint>()
        {
            1251, 2581, 3530, 3531, 6450, 6451, 8544, 8545, 14529, 14530, 21990, 21991, 34721, 34722
        };
        private WoWItem HaveItemCheck(List<uint> listId)
        {
            foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>(false))
            {
                if (listId.Contains(item.Entry))
                {
                    return item;
                }
            }
            return null;
        }
        static int NumOfItemsInBag(uint entry)
        {
            return Lua.GetReturnValues("return GetItemCount (\"" + entry.ToString() + "\")", "fish.lua")[0].ToInt32();
        }
        WoWSkill _firstAid = ObjectManager.Me.GetSkill(SkillLine.FirstAid);
        Stopwatch sw = new Stopwatch();
        Stopwatch Timer = new Stopwatch();
        string meteam = null;
    
        public void Bandagespell()
        {
            if (ObjectManager.Me.IsAlliance)
            {
                meteam = "a";
            }
            if (ObjectManager.Me.IsHorde)
            {
                meteam = "h";
            }
            if (_firstAid.CurrentValue >= 425)
            {
                heavyfrostskill();
            }


            if (_firstAid.CurrentValue >= 400)
            {
                frostskill();
            }

            if ((_firstAid.CurrentValue >= 374) && (_firstAid.CurrentValue < 400))
            {
                heavynetherskill();
            }

            if ((_firstAid.CurrentValue >= 299) && (_firstAid.CurrentValue < 375))
            {
                netherskill();
            }

            if ((_firstAid.CurrentValue >= 289) && (_firstAid.CurrentValue < 299))
            {
                heavyruneskill();
            }

            if ((_firstAid.CurrentValue >= 259) && (_firstAid.CurrentValue < 289))
            {
                runeskill();
            }

            if ((_firstAid.CurrentValue >= 239) && (_firstAid.CurrentValue < 259))
            {
                heavymageskill();
            }

            if ((_firstAid.CurrentValue >= 209) && (_firstAid.CurrentValue < 239))
            {
                mageskill();
            }

            if ((_firstAid.CurrentValue >= 179) && (_firstAid.CurrentValue < 209))
            {
                heavysilkskill();

            }
            if ((_firstAid.CurrentValue >= 149) && (_firstAid.CurrentValue < 179))
            {
                silkskill();
            }

            if ((_firstAid.CurrentValue >= 114) && (_firstAid.CurrentValue < 150))
            {
                heavywoolskill();
            }

            if ((_firstAid.CurrentValue >= 79) && (_firstAid.CurrentValue < 115))
            {
                woolskill();
            }

            if ((_firstAid.CurrentValue >= 39) && (_firstAid.CurrentValue < 80))
            {
                heavylinenskill();

            }
            if ((_firstAid.CurrentValue >= 0) && (_firstAid.CurrentValue < 40))
            {
                linenskill();
            }

            if (ObjectManager.Me.HealthPercent < 55 && ObjectManager.Me.HealthPercent != 1 && !ObjectManager.Me.Combat)
            {
                useBandages();
                return;
            }
            if (needtrain())
            {
                firsttrain();
            }


           
        }
                
        

        private void useBandages()
        {
            WoWItem bandage = HaveItemCheck(BandageIds);
            if (!Equals(null, bandage))
            {
                Styx.Helpers.Logging.Write("Bandaging");
                Lua.DoString("UseItemByName(\"" + bandage.Entry + "\")");
                StyxWoW.SleepForLagDuration();
                Thread.Sleep(2500);
            }

            else
            {
                Styx.Helpers.Logging.Write("No Bandages in Backpack");
            }
        }
            
        

        struct Trainer
         {
            public Trainer(uint ID, String team, int Skill)
            {
                this.ID = ID;
                this.team = team;
                this.Skill = Skill;
            }
            public uint ID;
            public String team;
            public int Skill;
        }

        private static List<Trainer> firsttrainer = new List<Trainer>
        {
           new Trainer(4591, "h" , 350),
           new Trainer(5759, "h" , 350),
           new Trainer(17214, "a", 350),
           new Trainer(16662, "a", 350),
           
        };
         
        private void firsttrain()
        {
            bool Training = false;
            {
                if (!Training)
                {
                    List<WoWUnit> WoWUnitList = ObjectManager.GetObjectsOfType<WoWUnit>();
                    foreach (WoWUnit nearby in WoWUnitList)
                    {
                        foreach (Trainer t in firsttrainer)
                        {
                            if ((t.ID == nearby.Entry) && (t.team.Equals(meteam) || t.team.Equals("b")))
                            {

                                Logging.Write("Running to Trainer");
                                while (ObjectManager.Me.Location.Distance(nearby.Location) > ObjectManager.Me.InteractRange)
                                {
                                    Styx.Logic.Pathing.Navigator.MoveTo(nearby.Location);
                                    Thread.Sleep(100);
                                }
                                ObjectManager.Update();
                                nearby.Target();
                                Thread.Sleep(1000);
                                nearby.Interact();
                                Thread.Sleep(1000);
                                try
                                {
                                    if (GossipFrame.Instance.IsVisible)
                                    {
                                        foreach (var option in GossipFrame.Instance.GossipOptionEntries)
                                        {
                                            if (option.Type == GossipEntry.GossipEntryType.Trainer)
                                            {
                                                GossipFrame.Instance.SelectGossipOption(option.Index);
                                                break;
                                            }
                                        }
                                    }
                                }
                                catch (Exception e) { Logging.Write(e.ToString()); }
                                Thread.Sleep(1000);
                                Logging.Write("Training First Aid");
                                Lua.DoString("BuyTrainerService(0)");
                                Thread.Sleep(2000);
                                Lua.DoString("CloseTrainer()");
                                Training = true;
                                break;
                            }
                        }
                    }
                }
            }
           
        }


        private bool needtrain()
        {
             if (((_firstAid.MaxValue == 50) && (_firstAid.CurrentValue >= 40)) || ((_firstAid.MaxValue == 50) && (_firstAid.CurrentValue >= 50)) || ((_firstAid.MaxValue == 150) && (_firstAid.CurrentValue >= 80)) || ((_firstAid.MaxValue == 150) && (_firstAid.CurrentValue >= 115)) || ((_firstAid.MaxValue == 150) && (_firstAid.CurrentValue >= 150)) || ((_firstAid.MaxValue == 225) && (_firstAid.CurrentValue >= 180)) || ((_firstAid.MaxValue == 225) && (_firstAid.CurrentValue >= 210)) || ((_firstAid.MaxValue == 225) && (_firstAid.CurrentValue >= 225)) || ((_firstAid.MaxValue == 300) && (_firstAid.CurrentValue >= 240)) || ((_firstAid.MaxValue == 300) && (_firstAid.CurrentValue >= 275)) || ((_firstAid.MaxValue == 375) && (_firstAid.CurrentValue >= 290)) || ((_firstAid.MaxValue == 375) && (_firstAid.CurrentValue >= 325)))
             {
                 
                 return true;
             }
             return false;
         }
        
        private void linenskill()
        {
            foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
            {
                if (_itemlistband.Contains(item.Entry))
                {
                    if ((item.Entry) == 2589)
                    {
                        if (item.StackCount > 1)
                        {
                            WoWMovement.MoveStop();
                            Thread.Sleep(2000);
                            Styx.Logic.Combat.WoWSpell Linen1 = Styx.Logic.Combat.WoWSpell.FromId(3275);
                            Logging.Write("Making Linen Bandages");
                            Styx.Logic.Combat.SpellManager.Cast(Linen1);
                            Thread.Sleep(160);
                            
                        }
                    }
                }
            }
        }
                
         private void heavylinenskill()
        {
            foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
            {
                if (_itemlistband.Contains(item.Entry))
                {
                    if ((item.Entry) == 2589)
                    {
                        if (item.StackCount > 2)
                        {
                            WoWMovement.MoveStop();
                            Thread.Sleep(2000);
                            Styx.Logic.Combat.WoWSpell Linen2 = Styx.Logic.Combat.WoWSpell.FromId(3276);
                            Logging.Write("Making Heavy Linen Bandages");
                            Styx.Logic.Combat.SpellManager.Cast(Linen2);
                            Thread.Sleep(160);
                            
                        }
                    }
                }
            }
        }

         private void woolskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 2592)
                     {
                         if (item.StackCount > 1)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell woolen1 = Styx.Logic.Combat.WoWSpell.FromId(3277);
                             Logging.Write("Making Woolen Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(woolen1);
                             Thread.Sleep(160);
                             
                         }
                     }
                 }
             }
         }

         private void heavywoolskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 2592)
                     {
                         if (item.StackCount > 2)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell woolen2 = Styx.Logic.Combat.WoWSpell.FromId(3278);
                             Logging.Write("Making Heavy Woolen Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(woolen2);
                             Thread.Sleep(160);
                             

                         }
                     }
                 }
             }
         }


         private void silkskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 4306)
                     {
                         if (item.StackCount > 1)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Silk1 = Styx.Logic.Combat.WoWSpell.FromId(7928);
                             Logging.Write("Making Silk Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Silk1);
                             Thread.Sleep(160);
                             
                         }
                     }
                 }
             }
         }

         private void heavysilkskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 4306)
                     {
                         if (item.StackCount > 2)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Silk2 = Styx.Logic.Combat.WoWSpell.FromId(7929);
                             Logging.Write("Making Heavy Silk Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Silk2);
                             Thread.Sleep(160);
                             

                         }
                     }
                 }
             }
         }

         private void mageskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 4338)
                     {
                         if (item.StackCount > 1)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Mage1 = Styx.Logic.Combat.WoWSpell.FromId(10840);
                             Logging.Write("Making Mage Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Mage1);
                             Thread.Sleep(160);
                             
                         }
                     }
                 }
             }
         }

         private void heavymageskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 4338)
                     {
                         if (item.StackCount > 2)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Mage2 = Styx.Logic.Combat.WoWSpell.FromId(10841);
                             Logging.Write("Making Heavy Mage Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Mage2);
                             
                         }
                     }
                 }
             }
         }

         private void runeskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 14047)
                     {
                         if (item.StackCount > 1)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Rune1 = Styx.Logic.Combat.WoWSpell.FromId(18629);
                             Logging.Write("Making Rune Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Rune1);
                             Thread.Sleep(160);
                             
                             
                         }
                     }
                 }
             }
         }



         private void heavyruneskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 14047)
                     {
                         if (item.StackCount > 2)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Rune2 = Styx.Logic.Combat.WoWSpell.FromId(18630);
                             Logging.Write("Making Heavy Rune Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Rune2);
                             Thread.Sleep(160);
                           
                         }
                     }
                 }
             }
         }

         private void netherskill()
         {
             foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
             {
                 if (_itemlistband.Contains(item.Entry))
                 {
                     if ((item.Entry) == 21877)
                     {
                         if (item.StackCount > 1)
                         {
                             WoWMovement.MoveStop();
                             Thread.Sleep(2000);
                             Styx.Logic.Combat.WoWSpell Nether1 = Styx.Logic.Combat.WoWSpell.FromId(27032);
                             Logging.Write("Making Nether Bandages");
                             Styx.Logic.Combat.SpellManager.Cast(Nether1);
                             Thread.Sleep(160);
                             
                         }
                     }
                 }
             }
         }






        private void heavynetherskill()
        {
            foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
            {
                if (_itemlistband.Contains(item.Entry))
                {
                    if ((item.Entry) == 21877)
                    {
                        if (item.StackCount > 2)
                        {
                            WoWMovement.MoveStop();
                            Thread.Sleep(2000);
                            Styx.Logic.Combat.WoWSpell Nether2 = Styx.Logic.Combat.WoWSpell.FromId(27033);
                            Logging.Write("Making Heavy Nether Bandages");
                            Styx.Logic.Combat.SpellManager.Cast(Nether2);
                            Thread.Sleep(160);
                            
                        }
                    }
                }
            }
        }

        

        private void frostskill()
        {
            foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
            {
                if (_itemlistband.Contains(item.Entry))
                {
                    if (item.StackCount > 1)
                    {
                        WoWMovement.MoveStop();
                        Thread.Sleep(2000);
                        Styx.Logic.Combat.WoWSpell Frost1 = Styx.Logic.Combat.WoWSpell.FromId(45545);
                        Logging.Write("Making Frost Bandages");
                        Styx.Logic.Combat.SpellManager.Cast(Frost1);
                        Thread.Sleep(160);
                       
                    }

                    
                }
            }

        }
            
        

        private void heavyfrostskill()
        {
            foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>())
            {
                if (_itemlistband.Contains(item.Entry))
                {
                    if (item.StackCount > 2)
                    {
                        WoWMovement.MoveStop();
                        Thread.Sleep(2000);
                        Styx.Logic.Combat.WoWSpell Frost2 = Styx.Logic.Combat.WoWSpell.FromId(45546);
                        Logging.Write("Making HeavyFrost Bandages");
                        Styx.Logic.Combat.SpellManager.Cast(Frost2);
                        Thread.Sleep(160);
                        
                    }

                }
            }

        }
    }
}
